message(STATUS "Setting up Eosio Wasm Toolchain 1.3.0 at /usr")
set(CMAKE_SYSTEM_NAME WebAssembly)

set(EOSIO_CDT_VERSION "1.3.0")
set(EOSIO_WASMSDK_VERSION "1.3.0")

set(CMAKE_C_COMPILER "/usr/bin/eosio-cc")
set(CMAKE_CXX_COMPILER "/usr/bin/eosio-cpp")

set(CMAKE_C_FLAGS " -O3 ")
set(CMAKE_CXX_FLAGS " -O3 ")

set(WASM_LINKER "/usr/bin/eosio-ld")

set(CMAKE_C_LINK_EXECUTABLE "${WASM_LINKER} <LINK_FLAGS> <OBJECTS> -o <TARGET> <LINK_LIBRARIES>")
set(CMAKE_CXX_LINK_EXECUTABLE "${WASM_LINKER} <LINK_FLAGS> <OBJECTS> -o <TARGET> <LINK_LIBRARIES>")

set(CMAKE_AR "/usr/bin/eosio-ar" CACHE PATH "ar" FORCE)
set(CMAKE_RANLIB "/usr/bin/eosio-ranlib" CACHE PATH "ranlib" FORCE)
set(ABIGEN "/usr/bin/eosio-abigen")

# hack for CMake on Linux
set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)

# hack for OSX
set(CMAKE_OSX_SYSROOT="")
set(CMAKE_OSX_DEPLOYMENT_TARGET="")

macro(add_contract CONTRACT_NAME TARGET)
   add_executable( ${TARGET}.wasm ${ARGN} )
   target_compile_options( ${TARGET}.wasm PUBLIC -abigen )
   get_target_property(BINOUTPUT ${TARGET}.wasm BINARY_DIR)
   target_compile_options( ${TARGET}.wasm PUBLIC -abigen_output=${BINOUTPUT}/${TARGET}.abi )
   target_compile_options( ${TARGET}.wasm PUBLIC -contract ${CONTRACT_NAME} )
endmacro()
